# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ...core.datetime_utils import serialize_datetime
from ...core.pydantic_utilities import pydantic_v1


class AuthResponse(pydantic_v1.BaseModel):
    access_token: str = pydantic_v1.Field()
    """
    The bearer token you will pass in to subsequent API calls to authenticate.
    """

    expires_in: int = pydantic_v1.Field()
    """
    Tells you how long (in seconds) until your bearer token expires.
    """

    token_type: str = pydantic_v1.Field()
    """
    Will always be "Bearer"
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
