# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ...core.datetime_utils import serialize_datetime
from ...core.pydantic_utilities import pydantic_v1
from .currency import Currency
from .finance_type import FinanceType


class FinancesProperties(pydantic_v1.BaseModel):
    context: typing.Optional[FinanceType] = pydantic_v1.Field(default=None)
    """
    The type of figure
    """

    currency: typing.Optional[Currency] = pydantic_v1.Field(default=None)
    """
    The currency, if applicable
    """

    date: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    as-of date
    """

    from_date: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    start date
    """

    to_date: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    end date
    """

    type: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    A free-text definition of the type
    """

    value: float = pydantic_v1.Field()
    """
    The numerical amount
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
