# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ...core.datetime_utils import serialize_datetime
from ...core.pydantic_utilities import pydantic_v1
from .tag import Tag


class RiskIntelligenceProperties(pydantic_v1.BaseModel):
    authority: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    Government authority issuing the enforcement or risk intelligence action
    """

    date: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    as-of date
    """

    from_date: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    start date
    """

    list_: typing.Optional[str] = pydantic_v1.Field(alias="list", default=None)
    """
    Official list where the entity's risk information or enforcement action is recorded
    """

    program: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    Specific to sanctions risk. Sanctions program under which the entity is designated.
    """

    reason: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    Explanation or legal basis for the risk intelligence
    """

    to_date: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    end date
    """

    type: Tag = pydantic_v1.Field()
    """
    Type of risk intelligence
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        populate_by_name = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
