# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ...core.datetime_utils import serialize_datetime
from ...core.pydantic_utilities import pydantic_v1
from ...generated_types.types.country import Country
from ...generated_types.types.entities import Entities
from ...generated_types.types.risk import Risk
from .source_id import SourceId


class FilterList(pydantic_v1.BaseModel):
    """
    Filter your search on the following attributes.
    """

    source: typing.Optional[typing.List[SourceId]] = None
    country: typing.Optional[typing.List[Country]] = None
    state: typing.Optional[typing.List[str]] = None
    city: typing.Optional[typing.List[str]] = None
    entity_type: typing.Optional[typing.List[Entities]] = None
    bounds: typing.Optional[typing.List[str]] = None
    risk: typing.Optional[typing.List[Risk]] = None

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
