# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ...core.datetime_utils import serialize_datetime
from ...core.pydantic_utilities import pydantic_v1
from .company_type import CompanyType
from .embedded_entity import EmbeddedEntity
from .entity_registration_date import EntityRegistrationDate
from .entity_risk import EntityRisk
from .status import Status


class PsaEntity(EmbeddedEntity):
    """
    The entity that is possibly the same as the target entity.
    """

    risk: EntityRisk
    registration_date: typing.Optional[EntityRegistrationDate] = None
    company_type: typing.Optional[CompanyType] = None
    latest_status: typing.Optional[Status] = None

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        populate_by_name = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
